package com.oreilly.jent.jdbc;

/**
 * In general, you may use the code in this book in your programs and 
 * documentation. You do not need to contact us for permission unless 
 * you're reproducing a significant portion of the code. For example, 
 * writing a program that uses several chunks of code from this book does 
 * not require permission. Selling or distributing a CD-ROM of examples 
 * from O'Reilly books does require permission. Answering a question by 
 * citing this book and quoting example code does not require permission. 
 * Incorporating a significant amount of example code from this book into 
 * your product's documentation does require permission.
 * 
 * We appreciate, but do not require, attribution. An attribution usually 
 * includes the title, author, publisher, and ISBN. For example: 
 * 
 *   "Java Enterprise in a Nutshell, Third Edition, 
 *    by Jim Farley and William Crawford 
 *    with Prakash Malani, John G. Norman, and Justin Gehtland. 
 *    Copyright 2006 O'Reilly Media, Inc., 0-596-10142-2."
 *  
 *  If you feel your use of code examples falls outside fair use or the 
 *  permission given above, feel free to contact us at 
 *  permissions@oreilly.com.
 */

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;

public class TableViewer { 
  final static String jdbcURL = "jdbc:oracle:customerdb"; 
  final static String jdbcDriver = "oracle.jdbc.driver.OracleDriver"; 
  final static String table = "CUSTOMERS";
  public static void main(java.lang.String[] args) { 
    System.out.println("--- Table Viewer ---"); 
    
    try { 
      Class.forName(jdbcDriver); 
      Connection con = DriverManager.getConnection(jdbcURL, "", ""); 
      Statement stmt = con.createStatement(  ); 
      ResultSet rs = stmt.executeQuery("SELECT * FROM "+ table); 
      
      ResultSetMetaData rsmd = rs.getMetaData(  ); 
      int columnCount = rsmd.getColumnCount(  ); 
      for(int col = 1; col <= columnCount; col++) { 
        System.out.print(rsmd.getColumnLabel(col)); 
        System.out.print(" (" + rsmd.getColumnTypeName(col)+")"); 
        if(col < columnCount) 
          System.out.print(", "); 
      } 
      System.out.println(  ); 
      
      while(rs.next(  )) { 
        for(int col = 1; col <= columnCount; col++) { 
          System.out.print(rs.getString(col)); 
          if(col < columnCount) 
            System.out.print(", "); 
        } 
        System.out.println(  ); 
      } 
      
      rs.close(  ); 
      stmt.close(  ); 
      con.close(  ); 
    } 
    catch (ClassNotFoundException e) { 
      System.out.println("Unable to load database driver class"); 
    } 
    catch (SQLException e) { 
      System.out.println("SQL Exception: " + e.getMessage(  )); 
    } 
  } 
} 
